#include <stdio.h>

/* libfawk configuration */
typedef double fawk_num_t;
typedef long fawk_refco_t;
#define FAWK_API static
/*#define FAWK_DISABLE_FAWK_PRINT*/

/* include the single-c-source variant */
#include LANG_INC

void libfawk_error(fawk_ctx_t *ctx, const char *str, const char *loc_fn, long loc_line, long loc_col)
{
	fprintf(stderr, "Error: %s at %s %ld:%ld\n", str, loc_fn, loc_line, loc_col);
}

static int getch1(fawk_ctx_t *ctx, fawk_src_t *src)
{
	return getchar();
}

int main()
{
	fawk_ctx_t ctx;
	int res;

	fawk_init(&ctx);

	ctx.parser.get_char = getch1;

	res = LANG_PARSE(&ctx);

	if (fawk_call1(&ctx, "main") == 0) {
		fawk_cell_t res;
		fawk_execret_t er;

#warning push args
		fawk_call2(&ctx, 0);
		er = fawk_execute(&ctx, 1000);
		if (er == FAWK_ER_FIN) {
			fawk_pop(&ctx, &res);
			printf("\nResult: ");
			fawk_dump_cell(&res, 1);
			printf("\n");
			fawk_cell_free(&ctx, &res);
			assert(ctx.sp == 0);
		}
	}
	else
		fprintf(stderr, "Failed to call function main()\n");

	fawk_uninit(&ctx);



	return 0;
}
